function giveConsentAffiliate(detail) {
	if (detail !== null && typeof detail.aff_consent_adcell !== 'undefined') {
		CheckConsentAffiliate(detail, 'adcell');
	}

	if (detail !== null && typeof detail.aff_consent_belboon !== 'undefined') {
		CheckConsentAffiliate(detail, 'belboon');
	}

	if (detail !== null && typeof detail.aff_consent_bing !== 'undefined') {
		CheckConsentAffiliate(detail, 'bing');
	}

	if (detail !== null && typeof detail.aff_consent_awin !== 'undefined') {
		CheckConsentAffiliate(detail, 'awin');
	}

	if (detail !== null && typeof detail.aff_consent_pinterest !== 'undefined') {
		CheckConsentAffiliate(detail, 'pinterest');
	}

	if (detail !== null && typeof detail.aff_consent_tradetracker !== 'undefined') {
		CheckConsentAffiliate(detail, 'tradetracker');
	}

	if (detail !== null && typeof detail.aff_consent_tradedoubler !== 'undefined') {
		CheckConsentAffiliate(detail, 'tradedoubler');
	}

	if (detail !== null && typeof detail.aff_consent_webgains !== 'undefined') {
		CheckConsentAffiliate(detail, 'webgains');
	}

	if (detail !== null && typeof detail.aff_consent_hotjar !== 'undefined') {
		CheckConsentAffiliate(detail, 'hotjar');
	}

	if (detail !== null && typeof detail.aff_consent_twitter !== 'undefined') {
		CheckConsentAffiliate(detail, 'twitter');
	}

	if (detail !== null && typeof detail.aff_consent_facebook !== 'undefined') {
		if (detail.aff_consent_facebook === true) {
			setTimeout(function(){ 
				fbq('consent', 'grant');
			 }, 1400);
			console.log('Consent für Facebook gewährt');
		} else {
			fbq('consent', 'revoke');
			console.log('Consent für Facebook entzogen');
		}
	}
}

function CheckConsentAffiliate(detail, service, dependencies = '') {
	if (eval('detail.aff_consent_' + service) === true) {
		if (dependencies == '') {
			$('head script[data-aff-cmp-id="' + service  + '"]').each(function (index) {
				if (!this.hasAttribute('data-dep-id')) {
					setTimeout (function(f){
						AffilateAddScript(service, index, f, document.head, detail);
					}, 200, this);
				}
			});
			$('body script[data-aff-cmp-id="' + service  + '"]').each(function (index) {
				if (!this.hasAttribute('data-dep-id')) {
					setTimeout (function(f){
						AffilateAddScript(service, index, f, document.body, detail);
					}, 200, this);
				}
			});
			console.log('Consent für ' + service  + ' gewährt');
		} else {
			$('head script[data-aff-cmp-id="' + service  + '"][data-dep-id="' + dependencies  + '"]').each(function (index) {
				setTimeout (function(f){
					AffilateAddScript(service, index, f, document.head, detail);
				}, 200, this);
			});
			$('body script[data-aff-cmp-id="' + service  + '"][data-dep-id="' + dependencies  + '"]').each(function (index) {
				setTimeout (function(f){
					AffilateAddScript(service, index, f, document.body, detail);
				}, 200, this);
			});
			console.log('Consent für ' + service  +  ' (dep ' + dependencies + ') gewährt');
		}
	} else {
		console.log('Consent für ' + service  + ' entzogen');
	}
}

function AffilateAddScript(service, index, element, parent, detail) {
	var script = document.createElement("script");
	script.setAttribute("type", "text/javascript");
	script.async = true;
	script.defer = true;
	if (typeof $(element).attr('src') !== "undefined") {
		script.setAttribute("src", $(element).attr('src'));
	//	if (typeof $(element).attr('data-onload') !== "undefined") {
		//		//script.addEventListener('load', $(element).attr('data-onload'));
	//		script.onload = eval('window.onload = function() {' + $(element).attr('data-onload') + '};');
	//		console.log('loaded');
	//	}
	}
	//console.log($(element).text());
	//script.innerText =  $(element).text();
	setInnerHTML(script, $(element).text());
	script.setAttribute("data-aff-cmp-set-id", service);
	script.setAttribute("data-aff-consent-given", "true");
	if (element.hasAttribute('data-dependencies')) {
		script.addEventListener("load", function(event) {
			console.log(service + ': dependencies on src');
			CheckConsentAffiliate(detail, service, element.getAttribute('data-dependencies'));
		});
		if (!script.hasAttribute('src')) {
			console.log(service + ': dependencies without src');
			CheckConsentAffiliate(detail, service, element.getAttribute('data-dependencies'));
		}
	}
	element.parentNode.replaceChild(script, element);
}

var setInnerHTML = function(elm, html) {
  elm.innerHTML = html;
  Array.from(elm.querySelectorAll("script")).forEach( oldScript => {
    const newScript = document.createElement("script");
    Array.from(oldScript.attributes)
      .forEach( attr => newScript.setAttribute(attr.name, attr.value) );
    newScript.appendChild(document.createTextNode(oldScript.innerHTML));
    oldScript.parentNode.replaceChild(newScript, oldScript);
  });
}


